﻿using System.Collections.Generic;
using UnityEngine;
using UnityEngine.XR.ARFoundation; //(d1)
using UnityEngine.XR.ARSubsystems; //(d2)

public class PlaceObject : MonoBehaviour
{
    [SerializeField] // (d3)
    GameObject objectPrefab;

    ARRaycastManager raycastManager; //(d4)
    List<ARRaycastHit> hitList = new List<ARRaycastHit>(); // (d5)

    void Start()
    {
        raycastManager = GetComponent<ARRaycastManager>();
    }

    void Update()
    {
        if (Input.GetMouseButtonDown(0))
        {
            if (raycastManager.Raycast(
                Input.GetTouch(0).position, hitList,
                TrackableType.Planes)) // (d6)
            {
                Instantiate(
                    objectPrefab, hitList[0].pose.position,
                    hitList[0].pose.rotation);
            }
        }
    }
}