#『ステップアップUnity』の「Part2　モバイルAR開発の実践」のサンプルスクリプトとサンプルデータです。

## ファイル一覧

- Chaper01/PlaceObject.cs
- Chaper01/ARFoundationTest
- Chaper02/ARFoundationTest_iOS
- Chaper02/ARFoundationTest_Android
- Chaper03/Goal.fbx
- Chaper03/NetTexture.png
- Chaper03/BallTexture.png
- Chaper03/ARBasketball
- Chaper03/GameManager.cs
- Chaper04/GoalManager.cs
- Chaper04/ARBasketball
- Appendix/GoalManager.cs
- Appendix/ARBasketball

## ファイルの説明
### Unityプロジェクトの追加方法
サンプルデータの中にはUnityプロジェクトが含まれています。章ごとにUnityプロジェクトが分かれており、各章で必要な素材やスクリプトなどが含まれています。Unityエディタを実行することでそのまま動作させることができます。

UnityHub右上のAddボタンからこちらのフォルダを開くことでUnityProjectが開きます（図ではARFoundationTestフォルダ）。開く際にPackageManagerなどから必要なデータがインポートされます。

- UnityHub右上のAddボタン

![UnityHub右上のAddボタン](image/UnityHub-add.png)

- Unityプロジェクトのフォルダを開く

![Unityプロジェクトのフォルダを開く](image/UnityProject-open.png)

### 第1章（Chaper01）

- Chaper01/PlaceObject.cs

検出した平面をタップした位置にオブジェクトを配置するために必要なスクリプトです。
AR Session Originオブジェクトにアタッチして使用します。

- Chaper01/ARFoundationTest

ARFoundationTestのUnity Projectです。実行シーンは`Assets/Scenes/SampleScene.unity`です。
平面上のタップした位置にCubeを配置します。

※ビルド用の設定は含まれていません。第2章のプロジェクトにビルド用の設定が含まれています。

### 第2章（Chaper02）

- Chaper02/ARFoundationTest_iOS

ARFoundationTestのUnity Projectです。実行シーンは`Assets/Scenes/SampleScene.unity`です。

iOS用のビルド設定が含まれています。（Xcodeプロジェクトは含まれていません）
「Other Settings→Identification→Package Name」の項目は、「gihyo」の部分をご自身のidなど別の値に設定してください。ただし、XcodeのSigning & CapabilitiesタブのTeamの項目にご自身のApple IDのアカウントを設定していただく必要があります（詳しくは本書をご確認ください）。以降の章のサンプルも同様です。

![Xcode Teamsの設定](image/xcode_team.png)

- Chaper02/ARFoundationTest_Android

ARFoundationTestのUnity Projectです。実行シーンは`Assets/Scenes/SampleScene.unity`です。

Android用のビルド設定が含まれています。「Other Settings→Identification→Package Name」の項目は、「gihyo」の部分をご自身のidなど別の値に設定してください。

### 第3章（Chaper03）

- Chaper03/Goal.fbx

バスケットゴールの3Dモデルです。UnityEditorにドラッグ＆ドロップすることでインポートすることができます。ゴール時のアニメーションも含まれています。

- Chaper03/NetTexture.png

バスケットゴールのネットのテクスチャです。「Unlit→Transparent」のShaderを適用したマテリアルを使用します。
Goal.fbxのNetオブジェクトにアタッチします。

- Chaper03/BallTexture.png

バスケットボールの見た目にするためのテクスチャです。「Unlit→ Texture」のShaderを適用したマテリアルを使用します。
Ball Prefabにアタッチします。

- Chaper03/GameManager.cs

画面タップでバスケットゴールを壁に設置、画面上方向にフリック入力でバスケットボールを投射する処理が書かれたスクリプトです。
AR Session Originオブジェクトにアタッチして使用します。

- Chaper03/ARBasketball

ARBasketballのUnity Projectです。実行シーンは`Assets/ARBasketball.unity`です。

画面タップでバスケットゴールを壁に設置、画面上方向にフリック入力でバスケットボールを投射します。UnityEditorでデバッグできるようにQuad、PlaneオブジェクトがHierarchyウィンドウに追加されています。

※ビルド用の設定は含まれていません。

### 第4章（Chaper04）

- Chaper04/GoalManager.cs

ボールがゴールに入った際にスコア加算、エフェクト発生、ゴールアニメーションを再生するスクリプトです。
HitAreaオブジェクトにアタッチして使用します。

- Chaper04/ARBasketball

ARBasketballのUnity Projectです。タッチでゴール設置、フリックでボールを投げ、ゴールに入ったら得点加算とエフェクトを表示しアニメーションを再生するゲームの完成版です。実行シーンは`Assets/ARBasketball.unity`です。

iOS/Android用のビルド設定が含まれています（Xcodeプロジェクトは含まれていません）。
「Other Settings→Identification→Package Name」の項目は、「gihyo」の部分をご自身のidなど別の値に設定してください。

### 付録 デバッグ用平面を非表示にする
第4章で最後に触れた、デバッグ用平面を非表示にする機能に関する項目です。以下のページに別途解説を載せています。

[付録 デバッグ用平面を非表示にする](Appendix/README.md)

- Appendix/GoalManager.cs

第4章の内容に加えて下フリック入力によりデバッグ用平面を非表示にする機能が追加されています。HitAreaオブジェクトにアタッチして使用します。

- Appendix/ARBasketball

ARBasketballのUnity Projectです。第4章の内容に加えて下フリック入力によりデバッグ用平面を非表示にする機能が追加されています。実行シーンは`Assets/ARBasketball.unity`です。

iOS/Android用のビルド設定が含まれています（Xcodeプロジェクトは含まれていません）。
「Other Settings→Identification→Package Name」の項目は、「gihyo」の部分をご自身のidなど別の値に設定してください。
